<?php

/*
	Filename:	sqlqueries.php
	Author:		Rene Weber
	Version:	0.1

	Plugin for Cacti to manage sql Query files.
	These files can be used for graphs with 
	SQLQueries as Datasource.
	Please also import the according 
	Templatefiles 
*/


// GLOBAL VARIABLES ---------------------

$sqlfolder = "./plugins/sqlqueries/queries/";

// --------------------------------------



// --------------- NOTHING TO BE CHANGED BELOW THIS POINT ------------------

chdir('../../');
include("./include/auth.php");
include("./include/top_header.php");



if (!isset($_REQUEST['sqlaction'])){
	$_REQUEST['sqlaction']="default";
}
switch($_REQUEST['sqlaction']){
		
		case 'open': 	show_list();
			     	show_file();
			     	break;
		
		case 'edit': 	show_list();
			     	show_file();
			     	add_new();	
			     	break;

		case 'delete':  get_confirm();
				break;

		case 'confirm': if (!delete_it()){
					show_message("Could not delete File!");
				}else{
					show_message("Successfully deleted!");
				}	
				show_list();
				break;
		
		case 'save': 	if (!create_it()){
					show_message("File Exists already!");
					add_new();
				}else{
					show_message("Successfully Created!");
					show_list();
				}
			        break;	
	
		case 'add':	add_new();
				break;	
		default:	show_list(); 	 
				break;
}

include("./include/bottom_footer.php");



/*
	FUNCTION DECLARATION
*/


// Asks for Confirmation before final delete
function get_confirm() {
	global $colors;
	form_confirm("Are You Sure?", "Are you sure you want to delete the file <strong>'" . $_REQUEST["filename"] . "'</strong>?", "sqlqueries.php", "sqlqueries.php?sqlaction=confirm&filename=" . $_REQUEST["filename"]);
}

// Executes the final delete  
function delete_it() {
		global $sqlfolder;
		if (unlink($sqlfolder.$_REQUEST["filename"])){
			return true;	
		}
		return false;
}

// Caches the Content of the File when creating new files or editing existing ones
function createnew_cache(){
	if (!isset($_REQUEST["file_content"])) {
		if (isset($_REQUEST["filename"])) {
			$file_content=get_file_content();
			foreach($file_content as $line){
				echo $line;	
			}
		}
	}else{
		echo $_REQUEST["file_content"];		
	}

}

// Finally Creates the File
function create_it(){
	global $sqlfolder;
	if (!file_exists($sqlfolder.$_REQUEST["filename"]) || (file_exists($sqlfolder.$_REQUEST["filename"]) && $_REQUEST["overwrite"])){
		$fp=fopen($sqlfolder.$_REQUEST["filename"], "w");
		fputs($fp, $_REQUEST["file_content"]);
		fclose($fp);
		return true;
	}else{
		return false;
	}
}


// Lists all existing Files
function show_list(){
	global $colors; 	
	html_start_box("<strong>SQL Queries</strong>", "98%", $colors["header"], "3", "center", "sqlqueries.php?sqlaction=add");

	$display_text = array(
                "filename" => array("Filename", "ASC"),
                "dtime" => array("Filetime", "DESC"));

	if(isset($_REQUEST["sort_column"])){
		html_header_sort($display_text,$_REQUEST["sort_column"], $_REQUEST["sort_direction"],3);
	}else{	
		html_header_sort($display_text,"","",3);
	}	
	global $sqlfolder,$colors;
	$folder=dir($sqlfolder);
	$i=0;
	while($file=$folder->read()){
		if ($file!=".." && $file!="."){
			form_alternate_row_color($colors["alternate"],$colors["light"],$i);
			$time=date("d.m.Y h:i:s",filemtime($sqlfolder."/".$file));
				echo "<td><a class='linkEditMain' href='sqlqueries.php?sqlaction=open&filename=$file'>$file</a></td>";
				echo "<td>$time</td>";
				echo "<td align='right'><a href='sqlqueries.php?sqlaction=delete&filename=$file'><img src='../../images/delete_icon.gif' width='10' height='10' border='0' alt='Delete'></a></td>";
				echo "</tr>";
			$i++;
		}
	}
	html_end_box();	
}

// Gets content of a File
function get_file_content(){
	global $sqlfolder;
	
	$file_content=array();
	$fpointer=fopen($sqlfolder.$_REQUEST["filename"],"r");
	while (!feof($fpointer)){
		array_push($file_content, fgets($fpointer));
	}
	fclose($fpointer);

	return $file_content;
}

// Shows the Content of the File in a seperate Box
function show_file(){
	global $colors;
	global $sqlfolder;
	
	$file_content=get_file_content();
	html_start_box("<strong>File Content</strong>", "98%", $colors["header"], "3", "center", "sqlqueries.php?sqlaction=edit&filename=".$_REQUEST["filename"]);
	?>
	<tr><td><textarea name="file_content" cols="140" rows="5" readonly><?php 

	if(isset($file_content)){
		foreach($file_content as $line){
			echo $line;	
		}
	}
	?></textarea></td></tr>
	<?
	html_end_box();

}

// Form for Adding a new File
function add_new(){
	global $colors, $config;

        /* ================= input validation ================= */
        input_validate_input_number(get_request_var("id"));
        /* ==================================================== */

        display_output_messages();

        if (!empty($_REQUEST["id"])) {
                $document = db_fetch_row("select * from plugin_docs where id=" . $_REQUEST["id"]);
                $id = $_REQUEST['id'];
        }else{
                $_REQUEST["id"] = 0;
                $id = 0;
                $document = array('title' => '', 'data' => '');
        }
	
	
	html_start_box("<strong>Add New</strong>", "98%", $colors["header"], "3", "center", "");
	?>
	<form action="<?php echo $config['url_path'] ?>plugins/sqlqueries/sqlqueries.php" method="POST" name="sqlqueries">;
	<input type="hidden" name="sqlaction" value="save">
	<input type=hidden name=id value='<? echo $id?>'>";
	<? form_alternate_row_color($colors["alternate"],$colors["light"],1); ?>
		<td width="300">
			Scriptname:
		</td>
		<td>
			<input type="text" name="filename" value="<?php if(isset($_REQUEST["filename"])){echo $_REQUEST["filename"];} ?>">
			<input type="checkbox" name="overwrite"><font size="2">Overwrite if exists</font>
		</td>
	</tr>
	<? form_alternate_row_color($colors["alternate"],$colors["light"],0); ?>
		<td>
			Queries (one per row):
		</td>
		<td>
			<textarea name="file_content" cols="140" rows="5" ><?php createnew_cache(); ?></textarea>
		</td>
	</tr>
	<?
	html_end_box();
	form_save_button("sqlqueries.php?sqlaction=save","save");
	?>
	</form>
	<?
	

}

// Function for Displaying Messages
function show_message($msg){

	echo "<hr><center><font color='red' size='4'>$msg</center><hr>";
}

?>
